Updates: Implement StoreRemoteMedia for v3 and port Embed

GNU social comes with two plugins that add important media functionality.

Not talking neither about ImageEncoder nor VideoEncoder this time, but rather
about StoreRemoteMedia and Embed.

[StoreRemoteMedia](https://code.undefinedhackers.net/GNUsocial/gnu-social/src/branch/v3/plugins/StoreRemoteMedia)
fetches remote files when they are Linked in a note. I.e., when the major mimetype isn't `text`.
It usually fetches and attempts to generate a thumb, if there are no encoders, it drops.

[Embed](https://code.undefinedhackers.net/GNUsocial/gnu-social/src/branch/v3/plugins/Embed)
attempts to generate a page preview from opengraph and oembed. I.e., acts when the major mimetype is `text`.

We've changed so much with GNU social v3 that, regarding SRM there was
no possible port, just a full rewrite. The code of both plugins became
much easier of understanding and compact, while promoting the same
functionality with more stability.
