Updates: Improve the Attachments system

With the milestone "Port Media system from v2" we had ported the existing
attachment system. The fact is that this system wasn't good enough.

It's always important to start with the original code as that allows us
to review past decisions and understand all the corner cases.

Sadly, what motivated us to re-design the attachment system was the
non-considered corner cases.

Key commits:

* [32ad5dbd74 - [ENTITY] Split Attachment in various new entities](https://code.undefinedhackers.net/GNUsocial/gnu-social/commit/32ad5dbd74ebb369c4b3ed688e1fb78464fabe49)
* [c381e58d33 - [ENTITY] Refactor RemoteURL entities to Link](https://code.undefinedhackers.net/GNUsocial/gnu-social/commit/c381e58d3307e7dd07abeb9cf5b3998e34f5bd48)

The reasoning leading to these entities and structure is detailed in our
[wiki](http://agile.gnusocial.rocks/doku.php?id=attachment).

Some relevant observations:

- `Link` is now part of GNU social Data Representation terms. It represents
any remote URL being shared in a note.
- There's only one fixed directory for GSFiles.
